#include <stdio.h>
#include <string.h>

struct queue
{
	queue() {head=tail=0;}
	int empty() {return head==tail;}
	void push( int v ) {data[head++]=v;head%=1000;}
	int pop() {int v=data[tail++];tail%=1000;return v;}
	int data[1000];
	int head, tail;
};

int moves[100];
int prev[100];
int flow[100][100];
int Net[100][100];

int s = 0;
int t = 65;

int row( int f )
{
	return (f-1)/8+1;
}
int col( int f )
{
	return (f-1)%8+1;
}

int Adj( int f1, int f2 )
{
	if( f1 == f2 ) return 0;
	for( int i = 0; i < 32; ++i )
		if( f2 == moves[i] ) return 0;
	int r1 = row(f1);
	int c1 = col(f1);
	int r2 = row(f2);
	int c2 = col(f2);
	if( r1 == r2 ) return 1;
	if( c1 == c2 ) return 1;
	if( r1-r2 == c1-c2 ) return 1;
	if( r2-r1 == c1-c2 ) return 1;
	return 0;
}

int bfs()
{
	int i, u, v;
	int used[100];
	queue q;
	for( i = 0; i < 100; ++i )
		prev[i] = -1;
	memset( used, 0, sizeof(used) );
	q.push(s);
	used[s] = 1;

	while( !q.empty() )
	{
		u=q.pop();
		for( v = 0; v <= 65; ++v )
			if( !used[v] && (Net[u][v]-flow[u][v] > 0) )
			{
				used[v] = 1;
				prev[v] = u;
				q.push(v);
			}
	}
	if( !used[t] ) return 0;
	return 1;
}

int main()
{
	freopen( "input.txt", "r", stdin );
	freopen( "output.txt", "w", stdout );

	int i, d;
	char c;
	for( i = 0; i < 32; ++i )
	{
		scanf( "%c%d ", &c, &d );
		moves[i] = (c-'a')+(d-1)*8+1;
	}
	moves[32] = moves[0];

	memset( Net, 0, sizeof(Net) );
	memset( flow, 0, sizeof(flow) );

	for( i = 0; i < 32; ++i )
		for( int fld = 1; fld <= 64; ++fld )
			if( Adj( moves[i], fld ) && Adj( moves[i+1], fld ) )
			{
				Net[moves[i]][fld] = 1;
				Net[fld][t] = 1;
			}

	for( i = 0; i < 32; ++i )
		Net[0][moves[i]] = 1;

	int u, v;
	while( bfs() )
	{
		v = t;
		while( v != -1 )
		{
			u = prev[v];
			flow[u][v] = 1;
			flow[v][u] = -1;
			v = u;
		}
	}

	int ans[32];
	for( i = 0; i < 32; ++i )
	{
		for( int j = 1; j <= 64; ++j )
			if( flow[moves[i]][j] == 1 ) break;
		printf( "%c%d", col(j)-1+'a',row(j) );
		if( i < 31) putchar( ' ' );
		ans[i] = j;
	}
	for( i = 0; i < 32; ++i )
		for( int j = 0; j < 32; ++j )
			if( ans[i] == moves[j] ) printf( "aaa" );

	fclose( stdout );
	fclose( stdin );
	return 0;
}