type
   PElem = ^TElem;
   TElem = record
      i, j: integer;
      next: PElem;
   end;

var
   map: array [1..200, 1..200] of char;
   n, m: integer;
   i, j: integer;
   queue: PElem;
   count : integer;

procedure put(ii, jj: integer);
var
   elem, p: PElem;
begin
   New(elem);
   elem^.i := ii;
   elem^.j := jj;
   elem^.next := nil;
   if queue = nil then
      queue := elem
   else begin
      p := queue;
      while p^.next <> nil do
         p := p^.next;
      p^.next := elem;
   end;
end;

function empty: boolean;
begin
   empty := queue = nil;
end;

procedure get(var elem: TElem);
var
   p: PElem;
begin
   if queue <> nil then begin
      p := queue;
      queue := p^.next;
      elem := p^;
      Dispose(p);
   end;
end;

procedure fill;
var
   e: TElem;
begin
   while not empty do begin
      get(e);
      if (e.i > 1) and (map[e.i - 1, e.j] = '.') then begin
         map[e.i - 1, e.j] := '$';
         put(e.i - 1, e.j);
      end;
      if (e.j > 1) and (map[e.i, e.j - 1] = '.') then begin
         map[e.i, e.j - 1] := '$';
         put(e.i, e.j - 1);
      end;
      if (e.i < n) and (map[e.i + 1, e.j] = '.') then begin
         map[e.i + 1, e.j] := '$';
         put(e.i + 1, e.j);
      end;
      if (e.j < m) and (map[e.i, e.j + 1] = '.') then begin
         map[e.i, e.j + 1] := '$';
         put(e.i, e.j + 1);
      end;
   end;
end;

begin
   Assign(input, 'input.txt');
   Assign(output, 'output.txt');
   Reset(input);
   Rewrite(output);

   readln(n, m);
   for i := 1 to n do begin
      for j := 1 to m do
         read(map[i, j]);
      readln;
   end;

   queue := nil;

   map[1, 1] := '$';
   put(1, 1);
   fill;

   count := 0;
   for i := 1 to n do begin
      for j := 1 to m do
         if (map[i, j] = '*') and
            (((i > 1) and (map[i - 1, j] = '$')) or
             ((j > 1) and (map[i, j - 1] = '$')) or
             ((i < n) and (map[i + 1, j] = '$')) or
             ((j < m) and (map[i, j + 1] = '$'))) then
           inc(count);
   end;

   write(count);

   Close(input);
   Close(output);
end.