#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <values.h>

#pragma option -v-

typedef unsigned long ulong;
typedef unsigned int uint;

#define max(a,b) (a>b?a:b)
#define min(a,b) (a<b?a:b)

int K;
long K2;
const N = 535;
int T[N];
int Y[N];

int st = 0;

inline void div(int *d, long k) {
	int *p;
	long t=0;
	for (p=d+st; p<=d+N; p++) {
		long a = *p + t;
		t =  a%k*10000l;
		*p = a / k;
	}
	d[N-1] += (t>=5000);
}

inline void mul(int *d, long k) {
	int *p;
	long t=0;
	for (p=d+N-1; p>=d+st; p--) {
		long a = (long)*p*k + t;
		t = a/10000;
		*p = a%10000;
	}
	d[st] += (t>=5000);
}

inline void sub(int *d1, int *d2) {
	int *p1, *p2;
	long t=0;
	for (p1=d1+N-1, p2=d2+N-1; p1>=d1; p1--, p2--) {
		long a = *p1 - *p2 + t;
		if (a<0) {
			a+=10000;
			t = -1;
		} else t = 0;
		*p1 = a;
	}
}

inline void add(int *d1, int *d2) {
	int *p1, *p2;
	long t=0;
	for (p1=d1+N-1, p2=d2+N-1; p1>=d1+st; p1--, p2--) {
		long a = *p1 + *p2 + t;
		if (a>=10000) {
			a-=10000;
			t = 1;
		} else t = 0;
		*p1 = a;
	}
}

inline int is(int *a) {
	for (int i=0; i<N; i++) {
		if (a[i]) {
			st = i-1;
			return 1;
		}
	}
	return 0;
}

inline void calc() {
	T[0] = 1;
	K2 = K*K;
	div(T, K);
	int i=1;
	memcpy(Y, T, sizeof(T));
	do {
		div(Y, K2*(2*i+1));
		mul(Y, (2*i-1));
		if (i%2) {
			sub(T, Y);
		} else add(T, Y);
		i++;
		if (!is(Y)) break;
	} while (1);
}

int main() {
	FILE *fi = fopen("input.txt", "r");
	fscanf(fi, "%d", &K);
	fclose(fi);

	calc();

	FILE *fo = fopen("output.txt", "w");
	fputs("0.", fo);
	T[500] += (T[501]>=5000);
	for (int i=1; i<501; i++) {
		fprintf(fo, "%04d", T[i]);
	}
	fputc('\n', fo);
	fclose(fo);
	return 0;
}